package com.tongran.system.api.factory;

import com.tongran.common.core.domain.R;
import com.tongran.system.api.RemoteUserService;
import com.tongran.system.api.domain.EpsInitialTrafficDataRemote;
import com.tongran.system.api.domain.NodeBandwidth;
import com.tongran.system.api.domain.SysUser;
import com.tongran.system.api.model.LoginUser;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

/**
 * 用户服务降级处理
 * 
 * @author tongran
 */
@Component
public class RemoteUserFallbackFactory implements FallbackFactory<RemoteUserService>
{
    private static final Logger log = LoggerFactory.getLogger(RemoteUserFallbackFactory.class);

    @Override
    public RemoteUserService create(Throwable throwable)
    {
        log.error("用户服务调用失败:{}", throwable.getMessage());
        return new RemoteUserService()
        {
            @Override
            public R<LoginUser> getUserInfo(String username, String source)
            {
                return R.fail("获取用户失败:" + throwable.getMessage());
            }

            @Override
            public R<Boolean> registerUserInfo(SysUser sysUser, String source)
            {
                return R.fail("注册用户失败:" + throwable.getMessage());
            }

            @Override
            public R<Boolean> recordUserLogin(SysUser sysUser, String source)
            {
                return R.fail("记录用户登录信息失败:" + throwable.getMessage());
            }

            @Override
            public R<NodeBandwidth> getBandwidth(NodeBandwidth nodeBandwidth, String source) {
                return R.fail("获取服务器带宽失败:" + throwable.getMessage());
            }

            @Override
            public R<Boolean> saveBandwidth(NodeBandwidth nodeBandwidth, String source) {
                return R.fail("新增服务器带宽失败:" + throwable.getMessage());
            }

            @Override
            public R<EpsInitialTrafficDataRemote> query(EpsInitialTrafficDataRemote queryParam, String source) {
                return R.fail("获取初始流量数据失败:" + throwable.getMessage());
            }
            @Override
            public R<Boolean> batchInitialTraffic(EpsInitialTrafficDataRemote queryParam, String source) {
                return R.fail("新增初始流量数据失败:" + throwable.getMessage());
            }
            @Override
            public R<Boolean> autoSaveServiceTrafficData(EpsInitialTrafficDataRemote queryParam, String source) {
                return R.fail("保存流量数据失败:" + throwable.getMessage());
            }
        };
    }
}
